<?php

namespace backend\controllers;

use Yii;
use common\models\InventoryGroup;
use backend\models\InventoryGroupSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use common\models\Product;
use yii\data\ArrayDataProvider;

/**
 * InventoryGroupController implements the CRUD actions for InventoryGroup model.
 */
class InventoryGroupController extends \backend\controllers\BackendController
{
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all InventoryGroup models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new InventoryGroupSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single InventoryGroup model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
    	$model =  $this->findModel($id);
    	
    	$products = Product::find()->andWhere(['id_inventory_group' => $model->id_inventory_group])->all();
    	
    	$pdb = new ArrayDataProvider(
    			[
    				'pagination' => false,
    				'sort' => false,
    				'models' => $products
    			]
    			);
    	
        return $this->render('view', [
            'model' => $this->findModel($id),
        	'products' => $pdb
        ]);
    }

    /**
     * Creates a new InventoryGroup model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new InventoryGroup();

        $model->status = InventoryGroup::STATUS_ACTIVE;
        
        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['index' ]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }
    

    /**
     * Updates an existing InventoryGroup model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['index' ]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing InventoryGroup model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the InventoryGroup model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return InventoryGroup the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = InventoryGroup::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}
